﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using CustomTileControl.ViewModel;

namespace CustomTileControl.View
{
    /// <summary>
    /// Interaction logic for CardControl.xaml
    /// </summary>
    public partial class CardControl : UserControl
    {
        CardControlViewModel viewModel;
        public CardControl()
        {
            InitializeComponent();
            viewModel = (CardControlViewModel)this.DataContext;
        }

        public static readonly DependencyProperty SmallerTextProperty = DependencyProperty.Register("SmallerText", typeof(string), typeof(CardControl), new PropertyMetadata(null, OnSmallerTextChanged));

        public string SmallerText
        {
            get { return (string)GetValue(SmallerTextProperty); }
            set { SetValue(SmallerTextProperty, value); }
        }

        private static void OnSmallerTextChanged(DependencyObject obj, DependencyPropertyChangedEventArgs args)
        {
            ((CardControl)obj).viewModel.SmallerText = args.NewValue as string;
        }

        public static readonly DependencyProperty LargerTextProperty = DependencyProperty.Register("LargerText", typeof(string), typeof(CardControl), new PropertyMetadata(null, OnLargerTextChanged));

        public string LargerText
        {
            get { return (string)GetValue(SmallerTextProperty); }
            set { SetValue(SmallerTextProperty, value); }
        }

        private static void OnLargerTextChanged(DependencyObject obj, DependencyPropertyChangedEventArgs args)
        {
            ((CardControl)obj).viewModel.LargerText = args.NewValue as string;
        }
    }
}
