﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Media.Imaging;

namespace CustomTileControl.ViewModel
{
    public delegate void AddToLiveTileDelegate(int Key);
    public class TileControlViewModel : INotifyPropertyChanged
    {
        string _TableName, _GameName, _Section, _Gauge1Label, _Gauge2Label, _Card1SmallerText, _Card2SmallerText, _Card1LargerText, _Card2LargerText, _DeviceSerial, _Error;
        int _Gauge1Range1StartValue, _Gauge1Range1EndValue, _Gauge1Range2StartValue, _Gauge1Range2EndValue, _Gauge1Range3StartValue, _Gauge1Range3EndValue;
        int _Gauge2Range1StartValue, _Gauge2Range1EndValue, _Gauge2Range2StartValue, _Gauge2Range2EndValue, _Gauge2Range3StartValue, _Gauge2Range3EndValue;
        int _Key = 0, _Gauge1NeedleValue = 0, _Gauge2NeedleValue = 0, _DeviceStatus = -1, _TableCategoryKey = 0;
        bool _IsSelected = false;

        DateTime _LatestErrorDateTime,_GameDateTime;

        Visibility _Gauge2Visibility;
        GridLength secondGridLength = new GridLength(1, GridUnitType.Star);
        public event AddToLiveTileDelegate AddToLiveTile;
        DelegateCommand _AddToLiveViewCommand;

        public DelegateCommand AddToLiveViewCommand
        {
            get { return _AddToLiveViewCommand; }
            set { _AddToLiveViewCommand = value; RaiseProeprtyChanged("AddToLiveViewCommand"); }
        }

        public GridLength SecondGridLength
        {
            get { return secondGridLength; }
            set { secondGridLength = value; }
        }


        
        BitmapSource _TableImage;

        public string DeviceSerialGameName
        {
            get { return _Error; }
            private set
            {
                if (!string.IsNullOrWhiteSpace(DeviceSerial))
                    _Error = DeviceSerial;
                if (!string.IsNullOrWhiteSpace(GameName))
                {
                    if (_Error.Length > 0)
                        _Error += ", ";
                    _Error += GameName;
                }

                RaiseProeprtyChanged("DeviceSerialGameName");
            }
        }

        public string DeviceSerial
        {
            get { return _DeviceSerial; }
            set
            {
                _DeviceSerial = value;
                RaiseProeprtyChanged("DeviceSerial");
                DeviceSerialGameName = value;
            }
        }

        public string Section
        {
            get { return _Section; }
            set
            {
                _Section = value; RaiseProeprtyChanged("Section");
            }
        }

        public string TableName
        {
            get { return _TableName; }
            set { _TableName = value; RaiseProeprtyChanged("TableName"); }
        }

        public string GameName
        {
            get { return _GameName; }
            set
            {
                _GameName = value;
                RaiseProeprtyChanged("GameName");
                DeviceSerialGameName = value;
            }
        }

        public string Gauge2Label
        {
            get { return _Gauge2Label; }
            set { _Gauge2Label = value; RaiseProeprtyChanged("Gauge2Label"); }
        }

        public string Gauge1Label
        {
            get { return _Gauge1Label; }
            set { _Gauge1Label = value; RaiseProeprtyChanged("Gauge1Label"); }
        }

        public string Card1SmallerText
        {
            get { return _Card1SmallerText; }
            set { _Card1SmallerText = value; RaiseProeprtyChanged("Card1SmallerText"); }
        }

        public string Card2SmallerText
        {
            get { return _Card2SmallerText; }
            set { _Card2SmallerText = value; RaiseProeprtyChanged("Card2SmallerText"); }
        }

        public string Card1LargerText
        {
            get { return _Card1LargerText; }
            set { _Card1LargerText = value; RaiseProeprtyChanged("Card1LargerText"); }
        }

        public string Card2LargerText
        {
            get { return _Card2LargerText; }
            set { _Card2LargerText = value; RaiseProeprtyChanged("Card2LargerText"); }
        }

        public int Gauge1Range1StartValue
        {
            get { return _Gauge1Range1StartValue; }
            set { _Gauge1Range1StartValue = value; RaiseProeprtyChanged("Gauge1Range1StartValue"); }
        }

        public int Gauge1Range1EndValue
        {
            get { return _Gauge1Range1EndValue; }
            set { _Gauge1Range1EndValue = value; RaiseProeprtyChanged("Gauge1Range1EndValue"); }
        }

        public int Gauge1Range2StartValue
        {
            get { return _Gauge1Range2StartValue; }
            set { _Gauge1Range2StartValue = value; RaiseProeprtyChanged("Gauge1Range2StartValue"); }
        }

        public int Gauge1Range2EndValue
        {
            get { return _Gauge1Range2EndValue; }
            set { _Gauge1Range2EndValue = value; RaiseProeprtyChanged("Gauge1Range2EndValue"); }
        }

        public int Gauge1Range3StartValue
        {
            get { return _Gauge1Range3StartValue; }
            set { _Gauge1Range3StartValue = value; RaiseProeprtyChanged("Gauge1Range3StartValue"); }
        }

        public int Gauge1Range3EndValue
        {
            get { return _Gauge1Range3EndValue; }
            set
            {
                _Gauge1Range3EndValue = value;
                RaiseProeprtyChanged("Gauge1Range3EndValue");
            }
        }

        public int Gauge2Range1StartValue
        {
            get { return _Gauge2Range1StartValue; }
            set { _Gauge2Range1StartValue = value; RaiseProeprtyChanged("Gauge2Range1StartValue"); }
        }

        public int Gauge2Range1EndValue
        {
            get { return _Gauge2Range1EndValue; }
            set { _Gauge2Range1EndValue = value; RaiseProeprtyChanged("Gauge2Range1EndValue"); }
        }

        public int Gauge2Range2StartValue
        {
            get { return _Gauge2Range2StartValue; }
            set { _Gauge2Range2StartValue = value; RaiseProeprtyChanged("Gauge2Range2StartValue"); }
        }

        public int Gauge2Range2EndValue
        {
            get { return _Gauge2Range2EndValue; }
            set { _Gauge2Range2EndValue = value; RaiseProeprtyChanged("Gauge2Range2EndValue"); }
        }

        public int Gauge2Range3StartValue
        {
            get { return _Gauge2Range3StartValue; }
            set { _Gauge2Range3StartValue = value; RaiseProeprtyChanged("Gauge2Range3StartValue"); }
        }

        public int Gauge2Range3EndValue
        {
            get { return _Gauge2Range3EndValue; }
            set
            {
                _Gauge2Range3EndValue = value;
                RaiseProeprtyChanged("Gauge2Range3EndValue");
            }
        }

        public BitmapSource TableImage
        {
            get { return _TableImage; }
            set
            {
                _TableImage = value;
                RaiseProeprtyChanged("TableImage");

            }
        }

        public int Gauge2NeedleValue
        {
            get { return _Gauge2NeedleValue; }
            set
            {
                _Gauge2NeedleValue = value;
                RaiseProeprtyChanged("Gauage2NeedleValue");
                
                if (Gauge2NeedleValue > Gauge2Range3EndValue)
                {
                    Gauge2Range3EndValue = Gauge2NeedleValue;
                }
            }
        }

        public int Gauge1NeedleValue
        {
            get { return _Gauge1NeedleValue; }
            set
            {
                _Gauge1NeedleValue = value;
                RaiseProeprtyChanged("Gauage1NeedleValue");
                if (Gauge1NeedleValue > Gauge1Range3EndValue)
                {
                    Gauge1Range3EndValue = Gauge1NeedleValue;
                }
            }
        }

        public bool IsSelected
        {
            get { return _IsSelected; }
            set { _IsSelected = value; RaiseProeprtyChanged("IsSelected"); }
        }

        public int Key
        {
            get { return _Key; }
            set { _Key = value; RaiseProeprtyChanged("Key"); }
        }


        public Visibility Gauge2Visibility
        {
            get { return _Gauge2Visibility; }
            set
            {
                _Gauge2Visibility = value;
                if (value == Visibility.Visible)
                {
                    SecondGridLength = new GridLength(1, GridUnitType.Star);
                }
                else if (value == Visibility.Collapsed)
                {
                    SecondGridLength = new GridLength(1, GridUnitType.Auto);
                }
            }
        }

        public DateTime LatestErrorDateTime
        {
            get { return _LatestErrorDateTime; }
            set { _LatestErrorDateTime = value; RaiseProeprtyChanged("LatestErrorDateTime"); }
        }

        public int TableCategoryKey
        {
            get { return _TableCategoryKey; }
            set { _TableCategoryKey = value; RaiseProeprtyChanged("TableCategoryKey"); }
        }

        public int DeviceStatus
        {
            get { return _DeviceStatus; }
            set { _DeviceStatus = value; RaiseProeprtyChanged("DeviceStatus"); }
        }

        public TileControlViewModel()
        {
            AddToLiveViewCommand = new DelegateCommand(ExecuteAddToLiveViewCommand);
        }        

        void ExecuteAddToLiveViewCommand(object obj)
        {
            RaiseAddToLiveTileEvent();
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaiseProeprtyChanged(string PropertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(PropertyName));
            }
        }

        public void RaiseAddToLiveTileEvent()
        {
            if (AddToLiveTile != null)
            {
                AddToLiveTile(this.Key);
            }
        }

    }
}
